import { IRequest, IGetRequest } from "./expressRequest";
import { DataManager } from "../data/manager";
import { IDataItem, IDataTypeKeyed, IKeyedAndDataTypeKeyed } from "../core/data";
import { Query, IQueryPage } from "../core/query";
import { IDataInterceptionConfigFactory } from "../core/user";
export declare class DataController {
    private dataManager;
    private dataInterceptionConfig;
    constructor(dataManager: DataManager, dataInterceptionConfig?: IDataInterceptionConfigFactory);
    get(req: IRequest<string[], IDataItem, IKeyedAndDataTypeKeyed, {}>): Promise<void>;
    delete(req: IGetRequest<void, IKeyedAndDataTypeKeyed, void>): Promise<void>;
    runQuery(req: IRequest<Query, IDataItem[], void, IQueryPage>): Promise<void>;
    saveData(req: IRequest<IDataItem, IDataItem, IDataTypeKeyed, {
        refs: string[];
    }>): Promise<void>;
}
