import { IExpressApiRequest, ExpressRouteBuilder, ExpressApiRequest, IExpressRequest } from "rokot-apicontroller";
import { IProfile } from "../core/user";
export interface IRequest<TBody, TResponse, TParams, TQuery> extends IExpressApiRequest<TBody, TResponse, TParams, TQuery> {
    isAuthenticated(): boolean;
    isUnauthenticated(): boolean;
    user: IProfile;
    sendValidation(errors: {
        attribute: string;
        message: string;
    }[]): void;
    sendForbidden(): void;
    sendConflict(): void;
}
export interface IGetRequest<TResponse, TParams, TQuery> extends IRequest<void, TResponse, TParams, TQuery> {
}
export declare class CustomExpressApiRequest<TBody, TResponse, TParams, TQuery> extends ExpressApiRequest<TBody, TResponse, TParams, TQuery> implements IRequest<TBody, TResponse, TParams, TQuery> {
    user: IProfile;
    constructor(native: IExpressRequest);
    isAuthenticated(): boolean;
    isUnauthenticated(): boolean;
    sendValidation(errors: {
        attribute: string;
        message: string;
    }[]): void;
    sendConflict(): void;
    sendForbidden(): void;
}
export declare class CustomExpressRouteBuilder extends ExpressRouteBuilder {
    protected createHandler(req: IExpressRequest): CustomExpressApiRequest<any, any, any, any>;
}
