"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rokot_apicontroller_1 = require("rokot-apicontroller");
class CustomExpressApiRequest extends rokot_apicontroller_1.ExpressApiRequest {
    constructor(native) {
        super(native);
        this.user = native.request.user;
    }
    isAuthenticated() {
        return this.native.request.isAuthenticated();
    }
    isUnauthenticated() {
        return this.native.request.isUnauthenticated();
    }
    sendValidation(errors) {
        this.native.response.status(422).send({ errors });
    }
    sendConflict() {
        this.native.response.status(409).send("Conflict");
    }
    sendForbidden() {
        this.native.response.status(403).send("Forbidden");
    }
}
exports.CustomExpressApiRequest = CustomExpressApiRequest;
class CustomExpressRouteBuilder extends rokot_apicontroller_1.ExpressRouteBuilder {
    createHandler(req) {
        return new CustomExpressApiRequest(req);
    }
}
exports.CustomExpressRouteBuilder = CustomExpressRouteBuilder;
