"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const rokot_apicontroller_1 = require("rokot-apicontroller");
const manager_1 = require("../data/manager");
const injectTypes_1 = require("../ioc/injectTypes");
let ReleaseController = class ReleaseController {
    constructor(dataManager) {
        this.dataManager = dataManager;
    }
    routes(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const rel = yield this.dataManager.withTransaction((tx) => tslib_1.__awaiter(this, void 0, void 0, function* () { return yield this.dataManager.snapshot.saveSnapshot(tx); }));
            req.sendOk(rel);
        });
    }
    data(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const rel = yield this.dataManager.withTransaction((tx) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                if (!req.query.dataTypeKey) {
                    yield this.dataManager.data.release(tx);
                    return;
                }
                yield this.dataManager.data.releaseItem(req.query.dataTypeKey, req.query.key, tx);
            }));
            req.sendNoContent();
        });
    }
    getPendingChanges(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            //const key = await this.dataManager.snapshot.getSnapshotKey();
            const p = yield this.dataManager.data.getPending();
            req.sendOk(p);
        });
    }
};
tslib_1.__decorate([
    rokot_apicontroller_1.api.route("routes"),
    rokot_apicontroller_1.api.verbs("post"),
    rokot_apicontroller_1.api.middleware("adminprotect"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], ReleaseController.prototype, "routes", null);
tslib_1.__decorate([
    rokot_apicontroller_1.api.route("data"),
    rokot_apicontroller_1.api.verbs("post"),
    rokot_apicontroller_1.api.middleware("adminprotect"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], ReleaseController.prototype, "data", null);
tslib_1.__decorate([
    rokot_apicontroller_1.api.route("pending-changes"),
    rokot_apicontroller_1.api.verbs("get"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], ReleaseController.prototype, "getPendingChanges", null);
ReleaseController = tslib_1.__decorate([
    rokot_apicontroller_1.api.controller(injectTypes_1.InjectTypes.ReleaseController, "/release"),
    tslib_1.__metadata("design:paramtypes", [manager_1.DataManager])
], ReleaseController);
exports.ReleaseController = ReleaseController;
