import { IRequest, IGetRequest } from "./expressRequest";
import { DataManager } from "../data/manager";
import { ISiteRoute, ISiteRouteData, RoutesGather } from "../core/routes";
import { IdentityType } from "../core/data";
export declare class RouteTreeController {
    private dataManager;
    constructor(dataManager: DataManager);
    getSiteRoutesTree(req: IGetRequest<ISiteRoute, void, {
        gather?: RoutesGather;
    }>): Promise<void>;
    getRoutesTree(req: IGetRequest<ISiteRoute, {
        id: IdentityType;
    }, {
        gather?: RoutesGather;
    }>): Promise<void>;
    addChildRoute(req: IRequest<ISiteRouteData, IdentityType[], {
        parentId?: IdentityType;
    }, void>): Promise<void>;
    updateRoute(req: IRequest<ISiteRoute, ISiteRoute, void, void>): Promise<void>;
    deleteRoute(req: IGetRequest<boolean, {
        id: IdentityType;
    }, void>): Promise<void>;
}
