"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const rokot_apicontroller_1 = require("rokot-apicontroller");
const manager_1 = require("../data/manager");
const injectTypes_1 = require("../ioc/injectTypes");
let RouteTreeController = class RouteTreeController {
    constructor(dataManager) {
        this.dataManager = dataManager;
    }
    getSiteRoutesTree(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const d = yield this.dataManager.routes.makeRouteTree(this.dataManager.snapshot, req.query.gather || "AllRoutes");
            req.sendOk(d);
        });
    }
    getRoutesTree(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const d = yield this.dataManager.routes.makeRouteTree(this.dataManager.snapshot, req.query.gather || "AllRoutes", req.params.id);
            req.sendOk(d);
        });
    }
    addChildRoute(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const d = yield this.dataManager.routes.addRoute(req.params.parentId, req.body);
            req.sendOk(d);
        });
    }
    updateRoute(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const d = yield this.dataManager.routes.updateRoute(req.body);
            req.sendOk(d);
        });
    }
    deleteRoute(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const d = yield this.dataManager.routes.deleteRoute(this.dataManager.snapshot, req.params.id);
            req.sendOk(d);
        });
    }
};
tslib_1.__decorate([
    rokot_apicontroller_1.api.route(""),
    rokot_apicontroller_1.api.verbs("get"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], RouteTreeController.prototype, "getSiteRoutesTree", null);
tslib_1.__decorate([
    rokot_apicontroller_1.api.route(":id"),
    rokot_apicontroller_1.api.verbs("get"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], RouteTreeController.prototype, "getRoutesTree", null);
tslib_1.__decorate([
    rokot_apicontroller_1.api.route(":parentId?"),
    rokot_apicontroller_1.api.verbs("post"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], RouteTreeController.prototype, "addChildRoute", null);
tslib_1.__decorate([
    rokot_apicontroller_1.api.route(),
    rokot_apicontroller_1.api.verbs("put"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], RouteTreeController.prototype, "updateRoute", null);
tslib_1.__decorate([
    rokot_apicontroller_1.api.route(":id"),
    rokot_apicontroller_1.api.verbs("delete"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], RouteTreeController.prototype, "deleteRoute", null);
RouteTreeController = tslib_1.__decorate([
    rokot_apicontroller_1.api.controller(injectTypes_1.InjectTypes.RouteTreeController, "/routes"),
    tslib_1.__metadata("design:paramtypes", [manager_1.DataManager])
], RouteTreeController);
exports.RouteTreeController = RouteTreeController;
