"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const rokot_apicontroller_1 = require("rokot-apicontroller");
const manager_1 = require("../data/manager");
const injectTypes_1 = require("../ioc/injectTypes");
const auth_1 = require("../core/auth");
let SnapshotController = class SnapshotController {
    constructor(dataManager) {
        this.dataManager = dataManager;
    }
    // @api.route(":key")
    // @api.verbs("post")
    // async saveSnapshot(req: IGetRequest<{ key: string, id: IdentityType }, { key: string }, void>) {
    //   const d = await this.dataManager.snapshot.saveSnapshot(req.params.key);
    //   req.sendOk(d)
    // }
    getSnapshot(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const key = auth_1.isAdminUser(req.user) ? req.params.key : "release";
            const d = yield this.dataManager.snapshot.getSnapshot(key);
            req.sendOk(d);
        });
    }
};
tslib_1.__decorate([
    rokot_apicontroller_1.api.route(":key?"),
    rokot_apicontroller_1.api.verbs("get"),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], SnapshotController.prototype, "getSnapshot", null);
SnapshotController = tslib_1.__decorate([
    rokot_apicontroller_1.api.controller(injectTypes_1.InjectTypes.SnapshotController, "/snapshot"),
    tslib_1.__metadata("design:paramtypes", [manager_1.DataManager])
], SnapshotController);
exports.SnapshotController = SnapshotController;
