"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const rokot_apicontroller_1 = require("rokot-apicontroller");
const injectTypes_1 = require("../ioc/injectTypes");
const core_1 = require("../data/repo/core");
const schema_1 = require("../data/repo/schema");
let TestController = class TestController {
    constructor(schemas) {
        this.schemas = schemas;
    }
    // @api.route("db")
    // @api.verbs("get")
    testSchema(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const schemas = this.schemas;
            const now = core_1.Dates.now();
            const key1 = "key1_" + now;
            const key2 = "key2_" + now;
            const key3 = "key3_" + now;
            const dataTypeKey = "test-data";
            //const cw = await schemas.data.countWhere()
            const insert1 = yield schemas.data.insert({ data: { key: key1, dataTypeKey, dataItem: {}, updatedOn: core_1.Dates.now() } });
            const insert2 = yield schemas.data.insert({ returning: ["key"], data: { key: key2, dataTypeKey, dataItem: {}, updatedOn: core_1.Dates.now() } });
            const insert3 = yield schemas.data.insert({ returning: ["id"], data: { key: key3, dataTypeKey, dataItem: {}, updatedOn: core_1.Dates.now() } });
            const update1 = yield schemas.data.update({ where: { key: key1, dataTypeKey }, data: { dataItem: { v1: true } } });
            const update2 = yield schemas.data.update({ returning: ["dataItem", "deletedOn", "updatedOn"], where: { key: key2, dataTypeKey }, data: { dataItem: { v1: true } } });
            const update3 = yield schemas.data.update({ returning: ["dataItem", "deletedOn", "updatedOn"], where: { key: key3, dataTypeKey }, data: { dataItem: { v1: true } } });
            const cw1 = yield schemas.data.countWhere({ dataTypeKey });
            const select1 = yield schemas.data.select({ where: { dataTypeKey } });
            const select2 = yield schemas.data.select({ fields: ["id"], where: { dataTypeKey } });
            const select11 = yield schemas.data.select({ where: { dataTypeKey }, paging: { take: 1 } });
            const select21 = yield schemas.data.select({ fields: ["id"], where: { dataTypeKey }, paging: { take: 1, skip: 1 } });
            const select3 = yield schemas.data.selectOne({ where: { dataTypeKey, key: key1 } });
            const select4 = yield schemas.data.selectOne({ fields: ["id"], where: { dataTypeKey, key: key2 } });
            const delete1 = yield schemas.data.delete({ where: { key: key1, dataTypeKey } });
            const delete2 = yield schemas.data.delete({ where: { key: key2, dataTypeKey }, returning: ["id"] });
            const delete3 = yield schemas.data.delete({ where: { key: key3, dataTypeKey }, returning: schemas.data.schema.allKeys });
            const delete4 = yield schemas.data.delete({ where: { dataTypeKey }, returning: ["id"] });
            // const cw1 = await schemas.data.countWhere({dataTypeKey:"favourites"})
            // const data = await schemas.data.select({paging: {take: 10}, fields: ["key", "id"]})
            // const dataMin = await schemas.data.select({paging: {take: 5, skip: 5}, fields:["key", "dataTypeKey"]})
            //req.sendOk({cw, cw1, data, dataMin, insert1, insert2, update1, update2})
            req.sendOk({ insert1, insert2, insert3, update1, update2, update3, cw1, delete1, delete2, delete3, delete4, select1, select2, select3, select4, select11, select21 });
        });
    }
};
TestController = tslib_1.__decorate([
    rokot_apicontroller_1.api.controller(injectTypes_1.InjectTypes.TestController, "/test"),
    tslib_1.__metadata("design:paramtypes", [Object])
], TestController);
exports.TestController = TestController;
