import { IRequest, IGetRequest } from "./expressRequest";
import { DataManager } from "../data/manager";
import { IFileStore } from "rokot-upload-backend";
import { ICreateFileService, IPutChunkService, IUploadMetadata, IFileCreationResult, IS3FileStoreConfig } from "rokot-upload-backend";
import { IUpload } from "../core/upload";
import { IQueryPage } from "../core/query";
export declare const UploadFileKey = "upload-file";
export declare class UploadController {
    private dataManager;
    private createFileService;
    private putChunkService;
    private fileStore;
    static migrateS3Config: IS3FileStoreConfig;
    constructor(dataManager: DataManager, createFileService: ICreateFileService, putChunkService: IPutChunkService, fileStore: IFileStore);
    createFile(req: IRequest<IUploadMetadata, IFileCreationResult, void, void>): Promise<void>;
    putChunk(req: IRequest<any, void, void, void>): Promise<void>;
    getUpload(req: IGetRequest<IUpload, {
        id: string;
    }, void>): Promise<void>;
    migrateToS3(req: IGetRequest<void, void, IQueryPage>): Promise<void>;
    getContent(req: IGetRequest<any, {
        id: string;
    }, {
        width?: number;
        height?: number;
    }>): Promise<void>;
}
