"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("underscore");
function isAdminUser(profile) {
    return !!profile && !!profile.roles && hasAdminRole(profile.roles);
}
exports.isAdminUser = isAdminUser;
function hasAdminRole(profileRoles) {
    return profileRoles && profileRoles.length > 0 && !!_.some(profileRoles, isAdminRole);
}
exports.hasAdminRole = hasAdminRole;
function isAdminRole(profileRole) {
    return profileRole && profileRole.roleId === 1;
}
exports.isAdminRole = isAdminRole;
