"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const csvWriter = require("csv-write-stream");
const streams_1 = require("../controllers/streams");
function getCsvText(items) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        var writer = csvWriter();
        //writer.pipe(res)
        items.forEach(o => writer.write(o));
        writer.end();
        const buffer = yield streams_1.streamToString(writer);
        return buffer.toString();
    });
}
exports.getCsvText = getCsvText;
function writeCsvToResponse(res, filename, items) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        res.setHeader('Content-disposition', 'attachment; filename=' + filename);
        res.setHeader('Content-type', "text/plain");
        const text = getCsvText(items);
        res.attachment(filename);
        res.send(text);
        res.end();
    });
}
exports.writeCsvToResponse = writeCsvToResponse;
