export declare type IdentityType = string | number;
export interface IIdentity {
    id?: IdentityType;
}
export interface IKeyed {
    key: string;
}
export interface IDataTypeKeyed {
    dataTypeKey: string;
}
export interface IKeyedAndDataTypeKeyed extends IKeyed, IDataTypeKeyed {
}
export interface IDataItem extends IIdentity, IKeyed {
}
export interface ISeedDataNumberId {
    [id: number]: IDataItem;
}
export interface ISeedDataStringId {
    [id: string]: IDataItem;
}
export interface ISeedData {
    dataTypes: {
        [dataType: string]: ISeedDataNumberId | ISeedDataStringId;
    };
    queries: {
        [dataType: string]: {
            key: string;
            refs: IdentityType[];
        }[];
    };
}
export interface ISeedDataResolved {
    [dataType: string]: {
        key: string;
        data: IDataItem[];
    }[];
}
export declare function resolveSeedData(seedData: ISeedData): ISeedDataResolved;
