import { IIdentity, IdentityType, IKeyed } from "./data";
import { IComponent } from "./components";
export interface IWebConfig {
    siteUrl: string;
    siteName: string;
    isProduction: boolean;
    virtualRootPath?: string;
}
export interface ISiteSnapshot extends IIdentity, IKeyed {
    route: ISiteRoute;
}
export interface ISiteSnapshotItem extends IIdentity, IKeyed {
    current?: boolean;
}
export interface ISite extends IIdentity {
    name: string;
    url: string;
}
export interface ISiteRoute extends ISiteRouteData, IIdentity {
    childRoutes?: ISiteRoute[];
    components?: IComponent[];
    parentId?: IdentityType;
    _latestUpdatedOn?: string;
    _isReleased?: boolean;
}
export interface ISiteRouteMetadata {
    name: string;
    content: string;
}
export interface ISiteRouteData {
    title: string;
    url?: string;
    meta?: ISiteRouteMetadata[];
    excludeFromNav?: boolean;
    allowedRoles?: string[];
    additionalClassName?: string;
}
export declare type RoutesGather = "All" | "AllRoutes" | "SingleRoute";
