"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rokot_apicontroller_1 = require("rokot-apicontroller");
const clientWriter_1 = require("rokot-apicontroller/lib/express/clientWriter");
const fs = require("fs");
const rokot_log_1 = require("rokot-log");
const logger = rokot_log_1.ConsoleLogger.create("create-api-client", { level: "info" });
function normaliseRef(ref) {
    return ref.replace("declare ", "").replace(/ /g, "").replace(/;/g, "").replace(/\r/g, "").replace(/\n/g, "");
}
function extendApiClient(master, right) {
    if (right.refs && right.refs.length) {
        const masterRefs = master.refs.map(normaliseRef);
        right.refs.forEach(r => {
            if (masterRefs.indexOf(normaliseRef(r)) === -1) {
                master.refs.push(r);
            }
        });
    }
    if (right.controllers && right.controllers.length) {
        master.controllers.push(...right.controllers);
    }
    return master;
}
exports.extendApiClient = extendApiClient;
function createApiClient(inputPath) {
    return rokot_apicontroller_1.createDefaultApiClient(logger, inputPath);
}
exports.createApiClient = createApiClient;
function loadApiClientJson(inputPath) {
    return JSON.parse(fs.readFileSync(inputPath).toString());
}
exports.loadApiClientJson = loadApiClientJson;
function writeFetchApiClient(outputPath, apiClient) {
    //const b = fs.readFileSync(path.resolve("./source/core/auth.ts"))
    //const text = b.toString()
    //const idx = text.indexOf(";")
    //const inject = text.substring(idx + 1)
    return clientWriter_1.expressClientWriter(outputPath, apiClient, { mode: "All", genericResponseWrapper: (t) => `IFetchApiResponse<${t}>` }, `import {IFetchApiResponse} from "rokot-isomorphic-react"`).then(ok => {
        logger.trace(ok ? "Client written ok" : "Client generation failed");
        return ok;
    });
}
exports.writeFetchApiClient = writeFetchApiClient;
