"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const knexImport = require("knex");
class KnexConnection {
    constructor(config) {
        this.knex = knexImport(config);
    }
    test() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return yield this.knex.raw(KnexConnection.testSqlQuery).then(() => {
                return true;
            }).catch(e => {
                console.log("KNEX connection failed:", e);
                return false;
            });
        });
    }
    tx(action) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return yield this.knex.transaction((tx) => action(tx));
        });
    }
    destroy() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            try {
                return yield this.knex.destroy();
            }
            catch (e) {
                console.log("KNEX connection failed to destroy:", e);
            }
        });
    }
}
KnexConnection.testSqlQuery = 'select 1 as result';
exports.KnexConnection = KnexConnection;
