/// <reference types="knex" />
import * as knexImport from "knex";
import { ICosmosDataRepository, ICosmosUserRepository, ICosmosRoleRepository, ICosmosProfileRepository, ICosmosSnapshotRepository, ICosmosRoutesRepository } from "./repo/core";
import { KnexConnection } from "./knexConnection";
import { IRequest } from "../controllers/expressRequest";
export declare class DataManager {
    private connection;
    data: ICosmosDataRepository;
    routes: ICosmosRoutesRepository;
    snapshot: ICosmosSnapshotRepository;
    profile: ICosmosProfileRepository;
    role: ICosmosRoleRepository;
    user: ICosmosUserRepository;
    constructor(connection: KnexConnection, data: ICosmosDataRepository, routes: ICosmosRoutesRepository, snapshot: ICosmosSnapshotRepository, profile: ICosmosProfileRepository, role: ICosmosRoleRepository, user: ICosmosUserRepository);
    destroy(): Promise<void>;
    withTransaction<T>(action: (tx: knexImport.Transaction) => Promise<T>): Promise<T>;
    useSnapshot(req: IRequest<any, any, any, any>): Promise<boolean>;
}
