"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const auth_1 = require("../core/auth");
class DataManager {
    constructor(connection, data, routes, snapshot, profile, role, user) {
        this.connection = connection;
        this.data = data;
        this.routes = routes;
        this.snapshot = snapshot;
        this.profile = profile;
        this.role = role;
        this.user = user;
    }
    destroy() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return yield this.connection.knex.destroy();
        });
    }
    withTransaction(action) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return yield this.connection.knex.transaction((tx) => action(tx));
        });
    }
    useSnapshot(req) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            if (auth_1.isAdminUser(req.user)) {
                const mode = req.headers["snapshot-key"];
                if (mode === "latest") {
                    return false;
                }
            }
            return yield this.snapshot.hasSnapshot();
        });
    }
}
exports.DataManager = DataManager;
