/// <reference types="knex" />
import * as knexImport from "knex";
import { IQuerySort, IQueryPage, IQueryWhere, IQuerySearch, IQueryData } from "../../core/query";
import { IDbQueryBuilder } from "../knexTable";
import { KnexConnection } from "../knexConnection";
export declare class PostgresQueryBuilder implements IDbQueryBuilder {
    connection: KnexConnection;
    constructor(connection: KnexConnection);
    applyQueryData(data: IQueryData, qb: knexImport.QueryBuilder): knexImport.QueryBuilder;
    applyPaging(builder: knexImport.QueryBuilder, paging: IQueryPage): knexImport.QueryBuilder;
    processSearch(jsonField: string, builder: knexImport.QueryBuilder, search: IQuerySearch): knexImport.QueryBuilder;
    processSort(jsonField: string, builder: knexImport.QueryBuilder, sort: IQuerySort): knexImport.QueryBuilder;
    private whereField(field, builder, where);
    processWhere(jsonField: string, builder: knexImport.QueryBuilder, where: IQueryWhere): knexImport.QueryBuilder;
    private repeatQueryToken(values);
}
