import { IProfile, IRoleKey, IUserProfile } from "../../core/user";
import { IQueryData } from "../../core/query";
import { IDbQueryBuilder } from "../knexTable";
import { ICosmosProfileRepository, ICosmosRoleRepository } from "./core";
import { Schema } from "./schema";
import { IdentityType } from "../../core/data";
export declare class ProfileRepository implements ICosmosProfileRepository {
    private schemas;
    private queryBuilder;
    private roleRepository;
    constructor(schemas: Schema.KnexTables, queryBuilder: IDbQueryBuilder, roleRepository: ICosmosRoleRepository);
    getProfileById(id: IdentityType): Promise<IProfile>;
    getProfiles(data?: IQueryData, roleKey?: IRoleKey): Promise<IUserProfile[]>;
    deleteProfile(profileId: IdentityType, context?: any): Promise<void>;
    createProfile(displayName: string, email: string, metadata: any, context?: any): Promise<IdentityType>;
    updateProfile(profile: IProfile, withRoles: boolean, context?: any): Promise<IProfile>;
}
