// import * as knexImport from "knex";
// import { Query, IQuery, isKeyQuery, IQueryParam, IQueryPage, INamedQuery, ensureArray } from "../../core/query";
// import * as _ from "underscore";
// import { KnexBase, IDbQueryBuilder } from "../knexBase";
// import { IdentityType } from "../../core/data";
// import { ICosmosQueryRepository, QueryParamType, Dates } from "./core";
// const queryField = "query"
// const queryParamsField = "queryparams"
// const idField = "id"
// const keyField = "key"
// const dataTypeKeyField = "datatypekey"
// const updatedOnField = "updated_on"
// export class QueryRepository  implements ICosmosQueryRepository {
//   private knexBase: KnexBase
//   constructor(private dbQueryBuilder: IDbQueryBuilder) {
//     this.knexBase = new KnexBase("cosmos.query", dbQueryBuilder.connection)
//   }
//   async executeQuery(query: Query, page?: IQueryPage, tx?: knexImport.Transaction): Promise<Query[]> {
//     let builder = this.applyInitialQueryFilter(this.knexBase.makeQueryBuilder(tx).select(idField, queryField), query)
//     if (isKeyQuery(query)) {
//       builder = builder.where(keyField, query.key)
//     } else {
//       builder = this.knexBase.applyPaging(builder, page || query.page)
//       if (query.sort && query.sort.length) {
//         query.sort.forEach(s => {
//           builder = this.dbQueryBuilder.processSort(queryField, builder, s)
//         })
//       }
//       if (query.where && query.where.length) {
//         query.where.forEach(w => {
//           builder = this.dbQueryBuilder.processWhere(queryField, builder, w)
//         })
//       }
//     }
//     return builder.then((docs: {}[]) => docs.map(d => {
//       const doc = d[queryField];
//       doc[idField] = d[idField]
//       return doc;
//     }))
//   }
//   async save(params: QueryParamType, query: Query, tx?: knexImport.Transaction): Promise<Query> {
//     return query.id ? this.update(params, query, tx) : this.insert(params, query, tx)
//   }
//   async insert(params: QueryParamType, query: Query, tx?: knexImport.Transaction): Promise<Query> {
//     return await this.knexBase.makeQueryBuilder(tx).insert(this.getUpdateData(query, params), [idField, queryField])
//       .then((docs: any[]) => {
//         return docs[0]
//       }).then(d => {
//         const jsonDoc = d[queryField]
//         jsonDoc.id = d.id;
//         return jsonDoc
//       })
//   }
//   async updateDirect(params: QueryParamType, query: Query, id: IdentityType, returnColumns: string[], tx?: knexImport.Transaction): Promise<Query> {
//     return await this.knexBase.makeQueryBuilder(tx).update(this.getUpdateData(query, params), [queryField, ...returnColumns]).where(idField, id)
//       .then((docs: any[]) => docs[0])
//   }
//   async update(params: QueryParamType, query: Query, tx?: knexImport.Transaction): Promise<Query> {
//     // TODO: Dont delete from passed instance - extend??
//     const id = query.id;
//     delete query.id;
//     return this.updateDirect(params, query, id, [], tx)
//       .then((docs: {}) => docs[queryField])
//       .then((doc) => {
//         doc.id = id;
//         return doc
//       })
//   }
//   async getNamedQueries(dataTypeKey?: string, page?: IQueryPage): Promise<INamedQuery[]> {
//     let builder = this.knexBase.makeQueryBuilder().select([idField, dataTypeKeyField, keyField, queryParamsField])
//     builder = this.knexBase.applyPaging(builder, page)
//     if (dataTypeKey) {
//       builder = builder.where(dataTypeKeyField, dataTypeKey)
//     }
//     return builder.then((datas) => datas.map(d => {
//       return {
//         id: d[idField],
//         dataTypeKey: d[dataTypeKeyField],
//         key: d[keyField], params: d[queryParamsField]
//       }
//     }))
//   }
//   protected getUpdateData<T extends Query>(query: T, params: { key: string }) {
//     const data: any = { [dataTypeKeyField]: query.dataTypeKey, [keyField]: params.key, [queryField]: JSON.stringify(query), [updatedOnField]: Dates.now() }
//     if (!isKeyQuery(query)) {
//       const qp = QueryParamResolver.makeParameters(query);
//       if (qp && qp.length) {
//         data[queryParamsField] = JSON.stringify(qp)
//       }
//     }
//     return data
//   }
//   protected applyInitialQueryFilter(builder: knexImport.QueryBuilder, query: Query): knexImport.QueryBuilder {
//     return builder.where(dataTypeKeyField, query.dataTypeKey)
//   }
// }
// export class QueryParamResolver {
//   private static regex = /\{([^}]+)\}/g
//   static queryParamsUsedInValue(value: string) {
//     if (!value) {
//       return []
//     }
//     const m = value.match(this.regex)
//     if (m && m.length) {
//       return _.uniq(m).map(p => p.substr(1, p.length - 2).trim())
//     }
//     return []
//   }
//   static makeParameters(query: IQuery) {
//     const params = this.findParameters(query);
//     return params && params.length && params.map(p => ({ name: p } as IQueryParam))
//   }
//   static findParameters(query: IQuery): string[] {
//     if (!query.where || !query.where.length) {
//       return;
//     }
//     return _.uniq(_.flatten(query.where.map(w => ensureArray(w.value).map(v => this.queryParamsUsedInValue(v)))))
//   }
// }
