import { IRole, IProfileRole, IDataTypeRelation, IDataTypeRelationRestriction } from "../../core/user";
import { IDbQueryBuilder } from "../knexTable";
import { IQueryData } from "../../core/query";
import { ICosmosRoleRepository } from "./core";
import { Schema } from "./schema";
import { IdentityType } from "../../core/data";
export declare class RoleRepository implements ICosmosRoleRepository {
    private schemas;
    private queryBuilder;
    constructor(schemas: Schema.KnexTables, queryBuilder: IDbQueryBuilder);
    getRolesForDataType(dataTypeKey: string): Promise<IRole[]>;
    getRolesRelationsForDataType(dataTypeKey: string): Promise<IDataTypeRelationRestriction[]>;
    getRoles(data?: IQueryData): Promise<IRole[]>;
    deleteUserRole(profileId: any, context?: any): Promise<void>;
    updateUserRole(profileId: number, roles: IProfileRole[], context?: any): Promise<IProfileRole[]>;
    getRoleById(id: string): Promise<IRole>;
    getProfileRoleDictionary(profileIds: number[]): Promise<{
        [profileId: number]: IProfileRole[];
    }>;
    getProfileRoles(profileId: number): Promise<IProfileRole[]>;
    createRole(name: string, metadata: IDataTypeRelation[], context?: any): Promise<IdentityType>;
}
