"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const core_1 = require("./core");
const schemaBuilder_1 = require("../schemaBuilder");
const jsonConvert = { convertToDb: m => m && JSON.stringify(m) };
const dateConvert = { convertFromDb: m => core_1.Dates.toIso(m), convertToDb: m => core_1.Dates.fromIso(m) };
const lowerCaseConvert = schemaBuilder_1.SchemaBuilder.makeColumn({ convertFromDb: m => m && m.toLowerCase(), convertToDb: m => m && m.toLowerCase() });
//export type DateString = string
var Schema;
(function (Schema) {
    let Data = class Data {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "data_item" }, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], Data.prototype, "dataItem", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "snapshot_data_item" }, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], Data.prototype, "snapshotDataItem", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "snapshot_updated_on" }, dateConvert)),
        tslib_1.__metadata("design:type", Object)
    ], Data.prototype, "snapshotUpdatedOn", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], Data.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({}),
        tslib_1.__metadata("design:type", String)
    ], Data.prototype, "key", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "datatypekey" }),
        tslib_1.__metadata("design:type", String)
    ], Data.prototype, "dataTypeKey", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "updated_on" }, dateConvert)),
        tslib_1.__metadata("design:type", String)
    ], Data.prototype, "updatedOn", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "deleted_on" }, dateConvert)),
        tslib_1.__metadata("design:type", String)
    ], Data.prototype, "deletedOn", void 0);
    Data = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("data")
    ], Data);
    Schema.Data = Data;
    let Role = class Role {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], Role.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({}),
        tslib_1.__metadata("design:type", String)
    ], Role.prototype, "name", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "datatypekey" }),
        tslib_1.__metadata("design:type", String)
    ], Role.prototype, "dataTypeKey", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Array)
    ], Role.prototype, "metadata", void 0);
    Role = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("role")
    ], Role);
    Schema.Role = Role;
    let ProfileRole = class ProfileRole {
        constructor() {
            this.metadata = "metadata";
        }
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], ProfileRole.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "profile_id" }),
        tslib_1.__metadata("design:type", Object)
    ], ProfileRole.prototype, "profileId", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "role_id" }),
        tslib_1.__metadata("design:type", Object)
    ], ProfileRole.prototype, "roleId", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "datatypekeylist" }, jsonConvert)),
        tslib_1.__metadata("design:type", Array)
    ], ProfileRole.prototype, "dataTypeKeyList", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], ProfileRole.prototype, "metadata", void 0);
    ProfileRole = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("profile_role")
    ], ProfileRole);
    Schema.ProfileRole = ProfileRole;
    let RoutesSnapshot = class RoutesSnapshot {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], RoutesSnapshot.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({}),
        tslib_1.__metadata("design:type", String)
    ], RoutesSnapshot.prototype, "key", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], RoutesSnapshot.prototype, "snapshot", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({ name: "created_on" }, dateConvert)),
        tslib_1.__metadata("design:type", String)
    ], RoutesSnapshot.prototype, "createdOn", void 0);
    RoutesSnapshot = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("routes_snapshot")
    ], RoutesSnapshot);
    Schema.RoutesSnapshot = RoutesSnapshot;
    let PasswordResetToken = class PasswordResetToken {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], PasswordResetToken.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "user_id" }),
        tslib_1.__metadata("design:type", Object)
    ], PasswordResetToken.prototype, "userId", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "token_hash" }),
        tslib_1.__metadata("design:type", String)
    ], PasswordResetToken.prototype, "tokenHash", void 0);
    PasswordResetToken = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("password_reset_token")
    ], PasswordResetToken);
    Schema.PasswordResetToken = PasswordResetToken;
    let VerificationToken = class VerificationToken {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], VerificationToken.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "user_id" }),
        tslib_1.__metadata("design:type", Object)
    ], VerificationToken.prototype, "userId", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "token_hash" }),
        tslib_1.__metadata("design:type", String)
    ], VerificationToken.prototype, "tokenHash", void 0);
    VerificationToken = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("verification_token")
    ], VerificationToken);
    Schema.VerificationToken = VerificationToken;
    let Profile = class Profile {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], Profile.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "display_name" }),
        tslib_1.__metadata("design:type", String)
    ], Profile.prototype, "displayName", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({}),
        tslib_1.__metadata("design:type", String)
    ], Profile.prototype, "email", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], Profile.prototype, "metadata", void 0);
    Profile = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("profile")
    ], Profile);
    Schema.Profile = Profile;
    let User = class User {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], User.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, lowerCaseConvert)),
        tslib_1.__metadata("design:type", String)
    ], User.prototype, "username", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "password_hash" }),
        tslib_1.__metadata("design:type", String)
    ], User.prototype, "passwordHash", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "profile_id" }),
        tslib_1.__metadata("design:type", Object)
    ], User.prototype, "profileId", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], User.prototype, "metadata", void 0);
    User = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("user")
    ], User);
    Schema.User = User;
    let Routes = class Routes {
    };
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.primaryKeyGenerated({}),
        tslib_1.__metadata("design:type", Object)
    ], Routes.prototype, "id", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "parent_id" }),
        tslib_1.__metadata("design:type", Object)
    ], Routes.prototype, "parentId", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({}),
        tslib_1.__metadata("design:type", Number)
    ], Routes.prototype, "position", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Array)
    ], Routes.prototype, "components", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column(Object.assign({}, jsonConvert)),
        tslib_1.__metadata("design:type", Object)
    ], Routes.prototype, "route", void 0);
    tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.column({ name: "updated_on" }),
        tslib_1.__metadata("design:type", String)
    ], Routes.prototype, "updatedOn", void 0);
    Routes = tslib_1.__decorate([
        schemaBuilder_1.SchemaBuilder.table("routes")
    ], Routes);
    Schema.Routes = Routes;
    Schema.tableSchemas = schemaBuilder_1.SchemaBuilder.createTableSchemas("cosmos", {
        data: Data,
        passwordResetToken: PasswordResetToken,
        profile: Profile,
        profileRole: ProfileRole,
        role: Role,
        routes: Routes,
        routesSnapshot: RoutesSnapshot,
        user: User,
        verificationToken: VerificationToken
    });
})(Schema = exports.Schema || (exports.Schema = {}));
