/// <reference types="knex" />
import * as knexImport from "knex";
import { ISiteSnapshot, IWebConfig } from "../../core/routes";
import { ICosmosSnapshotRepository, ICosmosRoutesRepository } from "./core";
import { SnapshotKey } from "../../core/release";
import { Schema } from "./schema";
export declare class SnapshotRepository implements ICosmosSnapshotRepository {
    private schemas;
    private routes;
    private webConfig;
    constructor(schemas: Schema.KnexTables, routes: ICosmosRoutesRepository, webConfig: IWebConfig);
    saveSnapshot(tx?: knexImport.Transaction): Promise<{
        key: string;
    }>;
    private keyQuery(tx?);
    getSnapshotKey(tx?: knexImport.Transaction): Promise<string>;
    getSnapshotKeys(tx?: knexImport.Transaction): Promise<string[]>;
    hasSnapshot(tx?: knexImport.Transaction): Promise<boolean>;
    getSnapshot(key: SnapshotKey, tx?: knexImport.Transaction): Promise<ISiteSnapshot>;
    private fetchLatest(tx);
    private fetchSnapshot(tx);
}
