import { ITokenRepository, IDataContext, IVersionedHash } from "rokot-auth";
import { Schema } from "./schema";
export declare class TokenRepository implements ITokenRepository {
    private schemas;
    constructor(schemas: Schema.KnexTables);
    getVerificationTokenHashes(username: string, context: IDataContext): Promise<IVersionedHash[]>;
    createVerificationTokenHash(username: string, verificationTokenHash: IVersionedHash, context: IDataContext): Promise<void>;
    destroyAllVerificationTokenHashes(username: string, context: IDataContext): Promise<void>;
    getPasswordResetTokenHashes(username: string, context: IDataContext): Promise<IVersionedHash[]>;
    createPasswordResetTokenHash(username: string, passwordResetTokenHash: IVersionedHash, context: IDataContext): Promise<void>;
    destroyAllPasswordResetTokenHashes(username: string, context: IDataContext): Promise<void>;
}
