import { IUser, INewUser, IDataContext, IVersionedHash } from "rokot-auth";
import { ICosmosUserRepository } from "./core";
import { Schema } from "./schema";
import { IdentityType } from "../../core/data";
export declare class UserRepository implements ICosmosUserRepository {
    private schemas;
    constructor(schemas: Schema.KnexTables);
    getProfileUsername(profileId: IdentityType, context: IDataContext): Promise<string>;
    userExists(username: string, context: IDataContext): Promise<boolean>;
    getUserByUsername(username: string, context: IDataContext): Promise<IUser & {
        profileId: IdentityType;
    }>;
    deleteUser(profileId: any, context?: any): Promise<boolean>;
    createUser(newUser: INewUser, context: IDataContext): Promise<void>;
    getPasswordHashByUsername(username: string, context: IDataContext): Promise<IVersionedHash>;
    setUserPassword(username: string, passwordHash: IVersionedHash, context: IDataContext): Promise<void>;
    onUserLogin(username: string, context: IDataContext): Promise<void>;
}
