/// <reference types="knex" />
import * as knexImport from "knex";
import { IdentityType } from "../../core/data";
import { ISiteRouteData, ISiteRoute, RoutesGather } from "../../core/routes";
import { ICosmosSnapshotRepository } from "../repo/core";
import { Schema } from "../repo/schema";
import { KnexTable } from "../knexTable";
export declare function buildTree(snapshotRepository: ICosmosSnapshotRepository, routesSchema: KnexTable<Schema.Routes>, mode: RoutesGather, tx?: knexImport.Transaction, id?: IdentityType): Promise<Schema.Routes & {
    key: string;
    _latestUpdatedOn?: string;
    _isReleased?: boolean;
    childRoutes?: (Schema.Routes & any)[];
}>;
export declare type RoutesFieldsExt = (Schema.Routes & {
    key: string;
    _latestUpdatedOn?: string;
    _isReleased?: boolean;
    childRoutes?: RoutesFieldsExt[];
});
export declare function convertRoute(data: RoutesFieldsExt, isChild?: boolean): ISiteRoute;
export declare function narrowSiteRoute(data: ISiteRoute): ISiteRouteData;
