/// <reference types="knex" />
import { KnexTable } from "./knexTable";
import * as knexImport from "knex";
import { KnexConnection } from "./knexConnection";
import { SchemaBuilder } from "./schemaBuilder";
export declare type KnexTableSchemaRecord<T> = {
    [P in keyof T]: KnexTable<T[P]>;
};
export declare type KnexTableSchemas<TSchema, T> = KnexTableSchemaRecord<TSchema> & {
    knex: knexImport;
    connection: KnexConnection;
};
export declare function getKnexTables<T>(tableSchemas: SchemaBuilder.CreatedTableSchemas<T>, connection: KnexConnection): KnexTableSchemas<typeof tableSchemas._typeRef, T>;
