/// <reference types="knex" />
/// <reference types="bunyan" />
import * as knexImport from "knex";
import { IApiConfig } from "../server/api";
import { Logger, LoggerLevel } from "rokot-log";
import { INodemailerSendgridOptions } from "../notification/dispatcher";
import { ICreateFileService, IFileStoreConfig, IFileStore, IFilenameGenerator, IUploadMetadata, IFileCreationResult } from "rokot-upload-backend";
import { IWebConfig } from "../core/routes";
import { IDataInterceptionConfigFactory, IUserConfig } from "../core/user";
import { Container } from "inversify";
import { IReleaseConfig } from "../core/release";
export declare class CreateFileService implements ICreateFileService {
    private fileStore;
    private filenameGenerator;
    constructor(fileStore: IFileStore, filenameGenerator: IFilenameGenerator);
    createFile(metadata: IUploadMetadata): Promise<IFileCreationResult>;
}
export interface IRunConfig {
    knex: knexImport.Config;
    api: IApiConfig;
    web: IWebConfig;
    release?: IReleaseConfig;
    user?: IUserConfig;
    fileStore: IFileStoreConfig;
    sendgrid: INodemailerSendgridOptions;
    dataInterception?: IDataInterceptionConfigFactory;
    onBeforeRun?(kernel: Container): void;
}
export declare function run(config: IRunConfig, loggerInit?: Logger | LoggerLevel): Promise<boolean>;
