"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Notifications {
    constructor(dispatcher) {
        this.dispatcher = dispatcher;
    }
    completeRegistrationNotification(recipient, payload) {
        return this.dispatcher.dispatch({ type: "complete-registration", recipient, token: payload.token, siteUrl: payload.siteUrl, name: payload.name });
    }
    rejectRegistrationNotification(recipient, payload) {
        return this.dispatcher.dispatch({ type: "reject-registration", recipient, name: payload.name, siteUrl: payload.siteUrl });
    }
    unknownRegistrationNotification(recipient, payload) {
        return this.dispatcher.dispatch({ type: "unknown-registration", recipient, subject: payload.subject, operation: payload.operation, name: payload.name, siteUrl: payload.siteUrl });
    }
    resetPasswordNotification(recipient, payload) {
        return this.dispatcher.dispatch({ type: "reset-password", recipient, token: payload.token, siteUrl: payload.siteUrl, name: payload.name });
    }
    notifyNonActivatedNotification(recipient, payload) {
        return this.dispatcher.dispatch({ type: "notify-non-activated", recipient, token: payload.token, siteUrl: payload.siteUrl, name: payload.name, subject: payload.subject });
    }
}
exports.Notifications = Notifications;
