"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const rokot_notification_1 = require("rokot-notification");
const settings_1 = require("./settings");
exports.notificationType = "unknown-registration";
let UnknownRegistrationHandler = class UnknownRegistrationHandler {
    testCase() {
        return { type: exports.notificationType, recipient: "email@email.com", name: "User name", subject: "Cannot reset password", operation: "reset password", siteUrl: "http://localhost/abc" };
    }
    html() {
        return settings_1.templatesFactory.combine(`${exports.notificationType}.html`, 'template-layout.html');
    }
    nodemailer(notification, transport) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return yield transport.send(notification.recipient, m => {
                m.from = transport.getFromAddress(notification);
                m.subject = notification.subject;
                //m.text = notification.text
                m.html = rokot_notification_1.notifications.transformTemplate(notification, this.html);
            });
        });
    }
};
tslib_1.__decorate([
    rokot_notification_1.notifications.testCase(),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", []),
    tslib_1.__metadata("design:returntype", Object)
], UnknownRegistrationHandler.prototype, "testCase", null);
tslib_1.__decorate([
    rokot_notification_1.notifications.template(),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", []),
    tslib_1.__metadata("design:returntype", void 0)
], UnknownRegistrationHandler.prototype, "html", null);
tslib_1.__decorate([
    rokot_notification_1.notifications.transport(),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object, Object]),
    tslib_1.__metadata("design:returntype", Promise)
], UnknownRegistrationHandler.prototype, "nodemailer", null);
UnknownRegistrationHandler = tslib_1.__decorate([
    rokot_notification_1.notifications.handler(exports.notificationType)
], UnknownRegistrationHandler);
