/// <reference types="express" />
import * as express from 'express';
import { PassportAuth } from "./passport";
export interface IApiConfig {
    port: number;
    authSecret: string;
    cookieDomain?: string;
    afterCreate?: (server: express.Express) => void;
    afterAuthConfig?: (server: express.Express) => void;
    afterRouteConfig?: (server: express.Express) => void;
    errorRequestHandler?: express.ErrorRequestHandler;
}
export declare class Api {
    private config;
    private passportAuth;
    constructor(config: IApiConfig, passportAuth: PassportAuth);
    run(): boolean;
}
