"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const propertyPathResolver_1 = require("./data/repo/propertyPathResolver");
const _ = require("underscore");
const obj = {
    a: "abc",
    b: [
        {
            b1: "b1-1"
        },
        {
            b1: "b1-2"
        }
    ],
    c: [
        {
            c1: "c1-1",
            c2: [
                { c21: "c1-1-1" },
                { c21: "c1-1-2" }
            ]
        },
        {
            c1: "c1-2",
            c2: [
                { c21: "c1-2-1" },
                { c21: "c1-2-2" }
            ]
        }
    ],
    d: {
        d1: "d1",
        d2: "d2",
        d3: [
            { d4: "d4-1" },
            { d4: "d4-2" }
        ]
    }
};
const obj1 = {};
const obj2 = {
    d: {
        d3: []
    }
};
function testGet(dataName, expect, o = obj) {
    const val = propertyPathResolver_1.PropertyPathResolver.getValue(o, dataName);
    console.log(`GET: ${dataName}`);
    console.log(val);
    console.log(_.isEqual(val, expect) ? "OK!" : "!!!!ERROR!!!!");
    console.log();
    return val;
}
function testSet(dataName) {
    const val = {};
    propertyPathResolver_1.PropertyPathResolver.setValue(val, dataName, propertyPathResolver_1.PropertyPathResolver.getValue(obj, dataName));
    console.log(`SET: ${dataName}`);
    console.log(JSON.stringify(val));
    console.log();
    return val;
}
testGet("a", "abc");
testGet("b.*.b1", ['b1-1', 'b1-2']);
testGet("c.*.c2.*.c21", ['c1-1-1', 'c1-1-2', 'c1-2-1', 'c1-2-2']);
testGet("d.d1", "d1");
testGet("d.d3.*.d4", ["d4-1", "d4-2"]);
testGet("a", undefined, obj1);
testGet("b.*.b1", undefined, obj1);
testGet("c.*.c2.*.c21", undefined, obj1);
testGet("d.d1", undefined, obj1);
testGet("d.d3.*.d4", undefined, obj1);
testGet("a", undefined, obj2);
testGet("b.*.b1", undefined, obj2);
testGet("c.*.c2.*.c21", undefined, obj2);
testGet("d.d1", undefined, obj2);
testGet("d.d3.*.d4", [], obj2);
testSet("a");
testSet("b.*.b1");
testSet("c.*.c2.*.c21");
//console.log(_.flatten(val))
//test("b.*")
//test("c.*.c1")
