"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/* NOTE: Uncomment the following test, then run 'npm test' to insert sample data (ONLY THIS TEST WILL RUN!) */
// describe.only("Inserting test data", () => {
//   it("Try Insert People", async () => {
//     const dataManager = new DataManager(new PostGresQueryBuilder({
//       host     : '127.0.0.1',
//       user     : 'postgres',
//       password : 'rocketmakers',
//       database : 'cosmos'
//     }))
//     await QueryTesting.insertPeople(dataManager)
//     dataManager.destroy()
//   });
//
//   it("Try Insert Named Queries", async () => {
//     const dataManager = new DataManager(new PostGresQueryBuilder({
//       host     : '127.0.0.1',
//       user     : 'postgres',
//       password : 'rocketmakers',
//       database : 'cosmos'
//     }))
//     await QueryTesting.insertNamedQuery(dataManager)
//     dataManager.destroy()
//   });
// })
function savePerson(dm, dataItem) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const inserted = yield dm.data.save({ dataTypeKey: "People" }, dataItem);
        console.log("SAVE OK", JSON.stringify(inserted, null, 2));
    });
}
class QueryTesting {
    static insertPeople(dm) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            try {
                yield savePerson(dm, { key: "joe", division: 1, firstName: "Joe", lastName: "Lewsey", joined: new Date(2016, 4, 17).toISOString() });
                yield savePerson(dm, { key: "danny", division: 1, firstName: "Danny", lastName: "Williamson", joined: new Date(2016, 4, 1).toISOString() });
                yield savePerson(dm, { key: "jason", division: 2, firstName: "Jason", lastName: "Dorell", joined: new Date(2016, 6, 3).toISOString() });
                yield savePerson(dm, { key: "simon", division: 3, firstName: "Simon", lastName: "Bevis", joined: new Date(2016, 2, 22).toISOString() });
                yield savePerson(dm, { key: "keith", division: 1, firstName: "Keith", lastName: "Walker", joined: new Date(2016, 4, 17).toISOString() });
                yield savePerson(dm, { key: "adam", division: 1, firstName: "Adam", lastName: "Walker", joined: new Date(2016, 4, 1).toISOString() });
                yield savePerson(dm, { key: "phil", division: 2, firstName: "Phil", lastName: "Mower", joined: new Date(2016, 6, 3).toISOString() });
                yield savePerson(dm, { key: "jonny", division: 3, firstName: "Jonny", lastName: "Stoten", joined: new Date(2016, 2, 22).toISOString() });
                return true;
            }
            catch (e) {
                console.log("PEOPLE ALREADY THERE!", e);
                return false;
            }
        });
    }
    static insertNamedQuery(dm) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            try {
                // let q: IQuery = createQuery("People")
                // q.page = { take: 20, skip: 0 }
                // q.sort = [{ field: "lastName" }, { field: "firstName" }]
                // await dm.query.save({ key: "LastFirst" }, q)
                // q = createQuery("People")
                // q.page = { take: 20, skip: 0 }
                // q.where = [WellKnownQueryWhere.betweenYearMonth("joined")];
                // await dm.query.save({ key: "JoinedYearMonth" }, q)
                return true;
            }
            catch (e) {
                console.log("NAMED QUERY ALREADY THERE!", e);
                return false;
            }
        });
    }
}
exports.QueryTesting = QueryTesting;
