// import { expect } from "rokot-test";
// import { IQueryParam, IQuery, IQueryWhere, enusureArray } from "../core/query";
// import { QueryParamResolver } from "../queryParams/queryParamResolver";
// // import {IUser} from "../core/user";
// // import {RoleRestrictions} from "../users/roleRestriction";
// import { Queries, QueryParameters, testDataTypeKey } from "./queryTestData";
//
// function generateParams(q: IQuery, expected: string[], expectThrow: boolean = false) {
//   const assertion: Chai.Assertion =
//     expect(() => {
//       const resolved = QueryParamResolver.findParameters(q.where);
//       expect(expected.length).to.be.eq(resolved.length)
//       const rs = resolved.sort()
//       const es = expected.sort()
//       for (let i = 0; i < rs.length; i++) {
//         const r = rs[i];
//         const e = es[i]
//         expect(r).to.be.eq(e)
//       }
//       logJson(resolved)
//     }).to
//   if (expectThrow) {
//     assertion.throw()
//   } else {
//     assertion.not.throw()
//   }
// }
//
// function logJson<T>(p: T) {
//   //console.log("JSON", JSON.stringify(p,null,2))
//   return p;
// }
//
// describe("Validate Query Param Generation", () => {
//   it("should parse a good query", () => {
//     const q = Queries.makeYearMonthQuery()
//     generateParams(q, ["year", "month", "toMonth", "toYear"])
//   });
//
//   it("should parse a query with repeated variable usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "{year}-{month}-01 {year} {year}"
//     generateParams(q, ["year", "month", "toMonth", "toYear"])
//   });
//
//   it("should parse a query with no variable usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "2016-01-01"
//     enusureArray(q.where[0].values)[1] = "2016-07-01"
//     generateParams(q, [])
//   });
//   it("should not parse a query with empty variable usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "2016-01-01{}"
//     enusureArray(q.where[0].values)[1] = "2016-07-01"
//     generateParams(q, [], true)
//
//     enusureArray(q.where[0].values)[0] = "2016-01-01{ }"
//     enusureArray(q.where[0].values)[1] = "2016-07-01"
//     generateParams(q, [], true)
//   });
//
//   it("should not parse a query with 'space in variable name' usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "{year}-{month }-01"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//     enusureArray(q.where[0].values)[0] = "{ year}-{month}-01"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//   });
//   it("should not parse a query with '{{' in field name usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "{{year}}-{month}-01"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//     enusureArray(q.where[0].values)[0] = "{{year}-{month}}-01"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//   });
//   it("should not parse a query with '}}' in field name usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "{year}}-{month}-01{"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//     enusureArray(q.where[0].values)[0] = "{year}}-{month}-01{"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//   });
//   it("should not parse a query with unmatched '{' and '}' in field usage", () => {
//     const q = Queries.makeYearMonthQuery()
//     enusureArray(q.where[0].values)[0] = "{year}}-{month}-01"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//     enusureArray(q.where[0].values)[0] = "{year} } }-{month}-01"
//     generateParams(q, ["year", "month", "toMonth", "toYear"], true)
//     enusureArray(q.where[0].values)[0] = "{ { {year} } }-{month}-01"
//   });
// });
//
// function resolveQuery(q: IQuery, qp: IQueryParam[], fromDate: string, toDate: string, expectThrow: boolean = false) {
//   const assertion: Chai.Assertion = expect(() => {
//     const resolved = QueryParamResolver.resolve(q, qp)
//     expect(resolved.where[0].values[0]).to.be.eq(fromDate)
//     expect(resolved.where[0].values[1]).to.be.eq(toDate)
//     logJson(resolved)
//   }).to
//   if (expectThrow) {
//     assertion.throw()
//   } else {
//     assertion.not.throw()
//   }
// }
//
// describe("Resolve Query Params", () => {
//   it("should run a good query", () => {
//     const q = Queries.makeYearMonthQuery()
//     const qp = QueryParameters.makeYearMonth("01", "02")
//     resolveQuery(q, qp, "2016-01-01", "2016-02-01")
//   });
//
//   it("should run a good query - allowing additional spurious params", () => {
//     const q = Queries.makeYearMonthQuery()
//     const qp = QueryParameters.makeYearMonth("01", "02")
//     qp.push({ name: "extra", value: "xtra" })
//
//     resolveQuery(q, qp, "2016-01-01", "2016-02-01")
//   });
//
//   it("should fail when missing required query parameter", () => {
//     const q = Queries.makeYearMonthQuery()
//     const qp = QueryParameters.makeYearMonth("01", "02")
//     qp.splice(0, 1)
//     resolveQuery(q, qp, "2016-01-01", "2016-02-01", true)
//   });
//
//   it("should fail with mispelt query parameter", () => {
//     const q = Queries.makeYearMonthQuery()
//     const qp = QueryParameters.makeYearMonth("01", "02")
//     qp[0].value = "yera"
//     resolveQuery(q, qp, "2016-01-01", "2016-02-01", true)
//   });
// })
