"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const query_1 = require("../core/query");
exports.testDataTypeKey = "People";
class Queries {
    static makeYearMonthQuery() {
        const q = query_1.createQuery(exports.testDataTypeKey);
        q.where = [this.makeYearMonthQueryWhere("date")];
        return q;
    }
    static makeYearMonthQueryWhere(field) {
        return { field, operation: "between", value: ["{year}-{month}-01", "{toYear}-{toMonth}-01"] };
    }
    static makeVariableQueryWhere(variableName) {
        return { field: "dummy", operation: "eq", value: [`{${variableName}}`] };
    }
}
exports.Queries = Queries;
class QueryParameters {
    static missingYear() {
        return [{ name: "month", value: "03" }, { name: "toYear", value: "2016" }, { name: "toMonth", value: "05" }];
    }
    static mispeltYear() {
        return [{ name: "yera", value: "03" }, { name: "month", value: "03" }, { name: "toYear", value: "2016" }, { name: "toMonth", value: "05" }];
    }
    static goodYearMonth() {
        return this.makeYearMonth("03", "05");
    }
    static makeYearMonth(startingMonth, endingMonth, startingYear = "2016", endingYear = startingYear) {
        return [{ name: "year", value: startingYear }, { name: "month", value: startingMonth }, { name: "toYear", value: endingYear }, { name: "toMonth", value: endingMonth }];
    }
}
exports.QueryParameters = QueryParameters;
