"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("underscore");
class PropertyPathResolver {
    getValue(data, dataName) {
        const parts = dataName.split(".");
        return _.reduce(parts, (result, p) => {
            if (!result || !p) {
                throw new Error(`${p} not found in data`);
            }
            return result[p];
        }, data);
    }
    setValue(data, dataName, value) {
        const parts = dataName.split(".");
        const lastIndex = parts.length - 1;
        _.each(parts, (p, i) => {
            if (!data || !p) {
                throw new Error(`${dataName} not found in data - failed on '${p}'`);
            }
            if (i === lastIndex) {
                data[p] = value;
                return;
            }
            data = data[p];
        });
    }
}
exports.PropertyPathResolver = PropertyPathResolver;
